Device = 16F628A   '  
Xtal = 4   '    4 
      
'    RA0, RA1
                                                           
'--------------------------   --------------------------------
                                                                   
Declare  SHOW_SYSTEM_VARIABLES = OFF   '    Proteus    
Declare  FSR_CONTEXT_SAVE = OFF   '       FSR
Declare  Reminders = OFF    '    
Declare  Warnings = OFF   '    
Declare  Optimiser_Level 0    '    
                                                          
'--------------------------   --------------------
                                                                
Config  BODEN_OFF, CP_OFF, WDT_OFF, LVP_OFF, MCLRE_OFF, INTOSC_OSC_NOCLKOUT 
                                                                   
                                                                   
'--------------------------   ---------------------------------

Declare  All_Digital = On   '     /
TRISA = %00110111   '   A
TRISB = %00000000     '   B
PORTA = $00           '   = 0
PORTB = $00           '   = 0                     

 PortB_Pullups = On   '     PORTB

 Symbol Enk1 PORTA.1   '  1
 Symbol Enk2 PORTA.0   '  2
 Symbol KEY PORTA.2    '  
 Symbol REL PORTA.3    '   
 Symbol DET_0 PORTA.4  '   

 CMCON = 7 '  
   
 Dim X As Byte  '    
 Dim A As Byte  '  
 Dim B As Byte  '  
 Dim DispConv As Byte  '    7  
 Dim Enk As Bit  '     
 Dim Save As Bit '   EEPROM
 EData 50 '   EEPROM    1 
 
 Symbol C1 PORTA.7 '  
 Symbol C2 PORTA.6 '  
 Symbol C3 PORTB.7 '  
 
 X = ERead 0  '   EEPROM  
 Enk = 0      '  
 Save = 0     '  

 DelayMS 500  ' 
                                                              

MAIN:
If KEY = 1 Then Pusk  '       Pusk

'===========   =============
If Enk1 = 1 Then Enk = 1  '   
 GoSub Disp  '   
    If Enk1 = 0 And Enk = 1 Then '    
     GoSub Encoder               '     Encoder 
    EndIf
'============================================
 GoSub Disp '   
GoTo MAIN   '                                                                                                                                   

'========   ==================
Pusk:
'========     0   ====== 
Repeat           ' 
Until DET_0 = 1  '     1
Repeat           ' 
Until DET_0 =0   '     0
'===============================================================
If X = 0 Then pusk2  '         
REL = 1    '  
'=====   20     ===========================
For A = 1 To X
DelayMS 19
DelayUS 500
Next A
REL = 0 '  
'===========       EEPROM ================
    If Save = 1 Then 
    EWrite 0,[X]
    Save = 0
    EndIf
'============================================ 
DelayMS 500
pusk1:
If KEY = 1 Then pusk1 '        
GoTo MAIN  '   

'      
pusk2:
 REL = 1  '  
 Repeat
 Until KEY = 0  '    
 REL = 0        '  
 DelayMS 500    ' 
'===========       EEPROM ================
    If Save = 1 Then 
    EWrite 0,[X]
    Save = 0
    EndIf
'============================================  
GoTo MAIN 

'========    ==========
Encoder:
 If Enk1 = 0 And Enk = 1 Then
    If Enk1 = 0 And Enk2 = 0 Then   '   
    If X = 0 Then Enc_P    '   = 0    
    Dec X                  '    1
Enc_P:
    Enk = 0
    Save = 1               '       EEPROM
    EndIf

    If Enk1 = 0 And Enk2 = 1 Then  '   
    Inc X                          '  
    If X > 200 Then X = 200        '   200 - 4   
    Enk = 0
    Save = 1               '       EEPROM
    EndIf
 EndIf
Return

Disp:
   B = X Dig 0 '  
   GoSub Convert '     
   C1 = 0 '    
   DelayUS 600  ' 
   C1 = 1 '   

   B = X Dig 1 '  
   GoSub Convert '     
   C2 = 0 '    
   DelayUS 600  ' 
   C2 = 1 '   

   B = X Dig 2 '  
   GoSub Convert '     
   C3 = 0 ' 3-    
   DelayUS 600  ' 
   C3 = 1 '   
Return

'========       PORTB ====
Convert:
   DispConv = LookUpL B, [191,134,219,207,230,237,253,135,255,239]
   PORTB = DispConv 
Return 
'=================================================================

End
                                                                   
                                                                   

